
<?php

/**
 * @category    Bozoo
 * @package     Bozoo DefaultShipping
 * @author      Volker Bohn, bozoo.com <volker.bohn@bozoo.com>
 * @copyright   Copyright (c) 2012 bozoo.com  - Volker Bohn (http://www.bozoo.com)
 */
class Bozoo_DefaultShipping_Model_Observer {

    public function apply_default_shipping() {

        try {
            $default_country = Mage::getStoreConfig('defaultshipping/general/default_country');
            $default_shipping_method = Mage::getStoreConfig('defaultshipping/general/default_shipping_method');


            if (Mage::getSingleton('checkout/cart')->getQuote()->getShippingAddress()->getCountryId() != $default_country ||
                    Mage::getSingleton('checkout/cart')->getQuote()->getShippingAddress()->getShippingMethod() != $default_shipping_method) {

                Mage::getSingleton('checkout/cart')->getQuote()->getShippingAddress()->setCountryId($default_country);

                if (Mage::getSingleton('checkout/cart')->getQuote()->getShippingAddress()->getShippingMethod() != $default_shipping_method) {
                    Mage::getSingleton('checkout/cart')->getQuote()->getShippingAddress()->setShippingMethod($default_shipping_method)->save();
                }
            }
        } catch (Mage_Core_Exception $e) {
            Mage::getSingleton('checkout/session')->addError($e->getMessage());
        } catch (Exception $e) {
            Mage::getSingleton('checkout/session')->addException($e, Mage::helper('checkout')->__('An error occured when trying to apply default shipping'));
        }
    }

}